using System;
using System.Collections.Generic;
using System.Text;
using OtterUnitTestFramework.Public;
using OtterUnitTestFramework.Public.Test;

namespace OtterUsageSample.test
{
    /// <summary>
    /// Test Case class
    /// </summary>
    class TestCaseSample : TestCaseTemplate
    {
        Sample sample = null;
        /// <summary>
        ///     <see cref="OtterUnitTestFramework.Public.Test.TestCaseTemplate.StartUp()"/>
        /// </summary>
        public override void StartUp()
        {
            //iniitialize stuff
            sample = new Sample();
        }

        /// <summary>
        ///     <see cref="OtterUnitTestFramework.Public.Test.TestCaseTemplate.TearDown()"/>
        /// </summary>
        public override void TearDown()
        {
            //clean stuff
            sample = null;
        }

        /// <summary>
        /// Execute an ordinary method
        /// </summary>
        public void TestCaseExecuteMethod()
        {
            sample.DoNothing();
        }

        /// <summary>
        /// Make true statements
        /// </summary>
        public void TestCasePassAssertions()
        {
            Assert.IsTrue(sample.ReturnTrue());
            Assert.IsNotNull(sample);
            Assert.AreEqual(sample, sample);
        }

        /// <summary>
        /// Fail assertions
        /// </summary>
        public void TestCaseFailAssertions()
        {
            Assert.IsTrue(sample.ReturnFalse());
            Assert.IsNotNull(null);
            Assert.AreEqual(sample, new Object());
        }

        /// <summary>
        /// Thrown an exception and and assert it.
        /// </summary>
        [ExpectedException(typeof(SampleException))]
        public void TestCaseExpectException()
        {
            sample.ThrowSampleException();
        }
    }
}
